;___________________________________________________________________
;
; XWINAPI: initialization file for XLISP-PLUS 3.04
;___________________________________________________________________

(defvar *XLISP-WINDOW* (get-active-window))

(defconstant +WM-NULL+  #x0000)
(defconstant +WM-CREATE+  #x0001)
(defconstant +WM-DESTROY+  #x0002)
(defconstant +WM-MOVE+  #x0003)
(defconstant +WM-SIZE+  #x0005)
(defconstant +WM-ACTIVATE+  #x0006)
(defconstant +WM-SETFOCUS+  #x0007)
(defconstant +WM-KILLFOCUS+  #x0008)
(defconstant +WM-ENABLE+  #x000A)
(defconstant +WM-SETREDRAW+  #x000B)
(defconstant +WM-SETTEXT+  #x000C)
(defconstant +WM-GETTEXT+  #x000D)
(defconstant +WM-GETTEXTLENGTH+  #x000E)
(defconstant +WM-PAINT+  #x000F)
(defconstant +WM-CLOSE+  #x0010)
(defconstant +WM-QUIT+  #x0012)
(defconstant +WM-ERASEBKGND+  #x0014)
(defconstant +WM-SYSCOLORCHANGE+  #x0015)
(defconstant +WM-SHOWWINDOW+  #x0018)
(defconstant +WM-WININICHANGE+  #x001A)
(defconstant +WM-DEVMODECHANGE+  #x001B)
(defconstant +WM-ACTIVATEAPP+  #x001C)
(defconstant +WM-GETICON+  #x007F)
(defconstant +WM-SETICON+  #x0080)
(defconstant +WM-GETDLGCODE+  #x0087)
(defconstant +WM-INITDIALOG+  #x0110)
(defconstant +WM-COMMAND+  #x0111)
(defconstant +WM-SYSCOMMAND+  #x0112)
(defconstant +WM-TIMER+  #x0113)
(defconstant +WM-HSCROLL+  #x0114)
(defconstant +WM-VSCROLL+  #x0115)

(defconstant +WA-INACTIVE+  0)
(defconstant +WA-ACTIVE+  1)
(defconstant +WA-CLICKACTIVE+  2)

;(defconstant +SW-HIDE+  0)          ;do much attention to use this constant.
(defconstant +SW-SHOWNORMAL+  1)
(defconstant +SW-NORMAL+  1)
(defconstant +SW-SHOWMINIMIZED+  2)
(defconstant +SW-SHOWMAXIMIZED+  3)
(defconstant +SW-MAXIMIZE+  3)
(defconstant +SW-SHOWNOACTIVATE+  4)
(defconstant +SW-SHOW+  5)
(defconstant +SW-MINIMIZE+  6)
(defconstant +SW-SHOWMINNOACTIVE+  7)
(defconstant +SW-SHOWNA+  8)
(defconstant +SW-RESTORE+  9)
(defconstant +SW-SHOWDEFAULT+  10)
(defconstant +SW-FORCEMINIMIZE+  11)
(defconstant +SW-MAX+  11)

;(defconstant +HIDE-WINDOW+  0)      ;do much attention to use this constant.
(defconstant +SHOW-OPENWINDOW+  1)
(defconstant +SHOW-ICONWINDOW+  2)
(defconstant +SHOW-FULLSCREEN+  3)
(defconstant +SHOW-OPENNOACTIVATE+  4)

(defconstant +CW-USEDEFAULT+    #x80000000)
(defconstant +WS-BORDER+    #x800000)
(defconstant +WS-CAPTION+   #xc00000)
(defconstant +WS-CHILD+ #x40000000)
(defconstant +WS-CHILDWINDOW+   #x40000000)
(defconstant +WS-CLIPCHILDREN+  #x2000000)
(defconstant +WS-CLIPSIBLINGS+  #x4000000)
(defconstant +WS-DISABLED+  #x8000000)
(defconstant +WS-DLGFRAME+  #x400000)
(defconstant +WS-GROUP+ #x20000)
(defconstant +WS-HSCROLL+   #x100000)
(defconstant +WS-ICONIC+    #x20000000)
(defconstant +WS-MAXIMIZE+  #x1000000)
(defconstant +WS-MAXIMIZEBOX+   #x10000)
(defconstant +WS-MINIMIZE+  #x20000000)
(defconstant +WS-MINIMIZEBOX+   #x20000)
(defconstant +WS-OVERLAPPED+    0)
(defconstant +WS-OVERLAPPEDWINDOW+  #xcf0000)
(defconstant +WS-POPUP+ #x80000000)
(defconstant +WS-POPUPWINDOW+   #x80880000)
(defconstant +WS-SIZEBOX+   #x40000)
(defconstant +WS-SYSMENU+   #x80000)
(defconstant +WS-TABSTOP+   #x10000)
(defconstant +WS-THICKFRAME+    #x40000)
(defconstant +WS-TILED+ 0)
(defconstant +WS-TILEDWINDOW+   #xcf0000)
(defconstant +WS-VISIBLE+   #x10000000)
(defconstant +WS-VSCROLL+   #x200000)
(defconstant +MDIS-ALLCHILDSTYLES+  1)

(defconstant +BS-3STATE+    5)
(defconstant +BS-AUTO3STATE+    6)
(defconstant +BS-AUTOCHECKBOX+  3)
(defconstant +BS-AUTORADIOBUTTON+   9)
(defconstant +BS-BITMAP+    128)
(defconstant +BS-BOTTOM+    #x800)
(defconstant +BS-CENTER+    #x300)
(defconstant +BS-CHECKBOX+  2)
(defconstant +BS-DEFPUSHBUTTON+ 1)
(defconstant +BS-GROUPBOX+  7)
(defconstant +BS-ICON+  64)
(defconstant +BS-LEFT+  256)
(defconstant +BS-LEFTTEXT+  32)
(defconstant +BS-MULTILINE+ #x2000)
(defconstant +BS-NOTIFY+    #x4000)
(defconstant +BS-OWNERDRAW+ #xb)
(defconstant +BS-PUSHBUTTON+    0)
(defconstant +BS-PUSHBOX+   10)
(defconstant +BS-PUSHLIKE+  4096)
(defconstant +BS-RADIOBUTTON+   4)
(defconstant +BS-RIGHT+ 512)
(defconstant +BS-RIGHTBUTTON+   32)
(defconstant +BS-TEXT+  0)
(defconstant +BS-TOP+   #x400)
(defconstant +BS-USERBUTTON+    8)
(defconstant +BS-VCENTER+   #xc00)
(defconstant +BS-FLAT+  #x8000)

(defconstant +CBS-AUTOHSCROLL+  64)
(defconstant +CBS-DISABLENOSCROLL+  #x800)
(defconstant +CBS-DROPDOWN+ 2)
(defconstant +CBS-DROPDOWNLIST+ 3)
(defconstant +CBS-HASSTRINGS+   512)
(defconstant +CBS-LOWERCASE+    #x4000)
(defconstant +CBS-NOINTEGRALHEIGHT+ #x400)
(defconstant +CBS-OEMCONVERT+   128)
(defconstant +CBS-OWNERDRAWFIXED+   16)
(defconstant +CBS-OWNERDRAWVARIABLE+    32)
(defconstant +CBS-SIMPLE+   1)
(defconstant +CBS-SORT+ 256)
(defconstant +CBS-UPPERCASE+    #x2000)

(defconstant +ES-AUTOHSCROLL+   128)
(defconstant +ES-AUTOVSCROLL+   64)
(defconstant +ES-CENTER+    1)
(defconstant +ES-LEFT+  0)
(defconstant +ES-LOWERCASE+ 16)
(defconstant +ES-MULTILINE+ 4)
(defconstant +ES-NOHIDESEL+ 256)
(defconstant +ES-NUMBER+    #x2000)
(defconstant +ES-OEMCONVERT+    #x400)
(defconstant +ES-PASSWORD+  32)
(defconstant +ES-READONLY+  #x800)
(defconstant +ES-RIGHT+ 2)
(defconstant +ES-UPPERCASE+ 8)
(defconstant +ES-WANTRETURN+    4096)

(defconstant +LBS-DISABLENOSCROLL+  4096)
(defconstant +LBS-EXTENDEDSEL+  #x800)
(defconstant +LBS-HASSTRINGS+   64)
(defconstant +LBS-MULTICOLUMN+  512)
(defconstant +LBS-MULTIPLESEL+  8)
(defconstant +LBS-NODATA+   #x2000)
(defconstant +LBS-NOINTEGRALHEIGHT+ 256)
(defconstant +LBS-NOREDRAW+ 4)
(defconstant +LBS-NOSEL+    #x4000)
(defconstant +LBS-NOTIFY+   1)
(defconstant +LBS-OWNERDRAWFIXED+   16)
(defconstant +LBS-OWNERDRAWVARIABLE+    32)
(defconstant +LBS-SORT+ 2)
(defconstant +LBS-STANDARD+ #xa00003)
(defconstant +LBS-USETABSTOPS+  128)
(defconstant +LBS-WANTKEYBOARDINPUT+    #x400)

(defconstant +SBS-BOTTOMALIGN+  4)
(defconstant +SBS-HORZ+ 0)
(defconstant +SBS-LEFTALIGN+    2)
(defconstant +SBS-RIGHTALIGN+   4)
(defconstant +SBS-SIZEBOX+  8)
(defconstant +SBS-SIZEBOXBOTTOMRIGHTALIGN+  4)
(defconstant +SBS-SIZEBOXTOPLEFTALIGN+  2)
(defconstant +SBS-SIZEGRIP+ 16)
(defconstant +SBS-TOPALIGN+ 2)
(defconstant +SBS-VERT+ 1)

(defconstant +SS-BITMAP+    #xe)
(defconstant +SS-BLACKFRAME+    7)
(defconstant +SS-BLACKRECT+ 4)
(defconstant +SS-CENTER+    1)
(defconstant +SS-CENTERIMAGE+   512)
(defconstant +SS-ENHMETAFILE+   #xf)
(defconstant +SS-ETCHEDFRAME+   #x12)
(defconstant +SS-ETCHEDHORZ+    16)
(defconstant +SS-ETCHEDVERT+    #x11)
(defconstant +SS-GRAYFRAME+ 8)
(defconstant +SS-GRAYRECT+  5)
(defconstant +SS-ICON+  3)
(defconstant +SS-LEFT+  0)
(defconstant +SS-LEFTNOWORDWRAP+    #xc)
(defconstant +SS-NOPREFIX+  128)
(defconstant +SS-NOTIFY+    256)
(defconstant +SS-OWNERDRAW+ #xd)
(defconstant +SS-REALSIZEIMAGE+ #x800)
(defconstant +SS-RIGHT+ 2)
(defconstant +SS-RIGHTJUST+ #x400)
(defconstant +SS-SIMPLE+    11)
(defconstant +SS-SUNKEN+    4096)
(defconstant +SS-WHITEFRAME+    9)
(defconstant +SS-WHITERECT+ 6)
(defconstant +SS-USERITEM+ 10)

(defconstant +DS-3DLOOK+    4)
(defconstant +DS-ABSALIGN+  1)
(defconstant +DS-CENTER+    #x800)
(defconstant +DS-CENTERMOUSE+   4096)
(defconstant +DS-CONTEXTHELP+   #x2000)
(defconstant +DS-CONTROL+   #x400)
(defconstant +DS-FIXEDSYS+  8)
(defconstant +DS-LOCALEDIT+ 32)
(defconstant +DS-MODALFRAME+    128)
(defconstant +DS-NOFAILCREATE+  16)
(defconstant +DS-NOIDLEMSG+ 256)
(defconstant +DS-SETFONT+   64)
(defconstant +DS-SETFOREGROUND+ 512)
(defconstant +DS-SYSMODAL+  2)

(defconstant +WS-EX-ACCEPTFILES+    16)
(defconstant +WS-EX-APPWINDOW+  #x40000)
(defconstant +WS-EX-CLIENTEDGE+ 512)
(defconstant +WS-EX-CONTEXTHELP+    #x400)
(defconstant +WS-EX-CONTROLPARENT+  #x10000)
(defconstant +WS-EX-DLGMODALFRAME+  1)
(defconstant +WS-EX-LEFT+   0)
(defconstant +WS-EX-LEFTSCROLLBAR+  #x4000)
(defconstant +WS-EX-LTRREADING+ 0)
(defconstant +WS-EX-MDICHILD+   64)
(defconstant +WS-EX-NOPARENTNOTIFY+ 4)
(defconstant +WS-EX-OVERLAPPEDWINDOW+   #x300)
(defconstant +WS-EX-PALETTEWINDOW+  #x188)
(defconstant +WS-EX-RIGHT+  #x1000)
(defconstant +WS-EX-RIGHTSCROLLBAR+ 0)
(defconstant +WS-EX-RTLREADING+ #x2000)
(defconstant +WS-EX-STATICEDGE+ #x20000)
(defconstant +WS-EX-TOOLWINDOW+ 128)
(defconstant +WS-EX-TOPMOST+    8)
(defconstant +WS-EX-TRANSPARENT+    32)
(defconstant +WS-EX-WINDOWEDGE+ 256)
(defconstant +WS-EX-LAYERED+     #x080000)

(princ "XLISP-PLUS 3.04 contains WINAPI functions, coded by Davide U. (2003)\n")
(princ "Type (demo-win) to run win32-api demo.\n")

;___________________________________________________________________


(defun send-message (&rest lrest)
    (call-winapi (apply #'concatenate 'string
        (princ-to-string (first lrest))
        (mapcan #'(lambda(x) (list "\177" (princ-to-string x)))
            (rest lrest)))))

(defun set-focus (old-win new-win)
    (send-message old-win +WM-KILLFOCUS+ new-win nil)
    (send-message new-win +WM-SETFOCUS+ old-win nil)
    (send-message new-win +WM-ACTIVATE+ +WA-ACTIVE+))

(defun color-base (index)
   (case index
      ( 0 (rgb-color 0 0 0))
      ( 1 (rgb-color 0 0 128))
      ( 2 (rgb-color 0 128 0))
      ( 3 (rgb-color 0 128 128))
      ( 4 (rgb-color 196 0 0))
      ( 5 (rgb-color 128 0 128))
      ( 6 (rgb-color 128 64 0))
      ( 7 (rgb-color 196 196 196))
      ( 8 (rgb-color 128 128 128))
      ( 9 (rgb-color 0 0  255))
      (10 (rgb-color 0 255 0))
      (11 (rgb-color 0 255 255))
      (12 (rgb-color 255 0 0))
      (13 (rgb-color 255 0 255))
      (14 (rgb-color 255 255 0))
      (15 (rgb-color 255 255 255))
      (16 (rgb-color 164 164 164))
      (17 (rgb-color 128 160 255))
      (18 (rgb-color 160 255 160))
      (19 (rgb-color 160 255 255))
      (20 (rgb-color 255 160 160))
      (21 (rgb-color 255 160 255))
      (22 (rgb-color 255 255 160))
      (23 (rgb-color 212 212 212))
      (24 (rgb-color 180 180 180))
      (25 (rgb-color 188 220 255))
      (26 (rgb-color 220 255 220))
      (27 (rgb-color 220 255 255))
      (28 (rgb-color 255 220 220))
      (29 (rgb-color 255 220 255))
      (30 (rgb-color 255 255 220))
      (31 (rgb-color 228 228 228))))

;
; A small demo that show the use of the win32-api functions that are embedded in Xlisp CL.

(defun demo-win ()

    (setq hwin1 (send-message nil 'createwindow "the hello program - window1" nil))
    (setq hwin2 (send-message nil 'createwindow "the hello program - window2" nil nil nil 400))
    (setq hbutt (send-message hwin2 'createbutton "caption button2" nil)) ;; 0 22 200 20))
    (setq hedit (send-message hwin2 'createedit      "test2" nil)) ;; 0 0 200 20))
    (setq hcmbb (send-message hwin2 'createcombobox  "test2" nil)) ;; 0 44 200 80))
    (setq hlstb (send-message hwin2 'createlistbox   "test2" nil)) ;; 0 70 200 80))
    (setq hstat (send-message hwin2 'createstatic    "test2" nil)) ;; 0 140 200 20))
   ;(setq hscrb (send-message hwin2 'createscrollbar "test2" nil)) ;; 205 0 16 160))
    (setq hscrb (send-message hwin2 'createscrollbar "test2"
                    (+ +SBS-HORZ+ +WS-CHILD+ +WS-VISIBLE+ 
                       +WS-TABSTOP+ +WS-GROUP+ +WS-CLIPSIBLINGS+ +WS-CLIPCHILDREN+)
                    205 0 120 16))

    (setq hbut1 (send-message hwin1 'createbutton "caption button1" nil 20 20 200 50))
    (setq hedi1 (send-message hwin1 'createedit "test1"))

    (set-focus nil *XLISP-WINDOW*)
    (show-window *XLISP-WINDOW* +SW-MINIMIZE+)

    (set-focus *XLISP-WINDOW* hwin1)
    (send-message hwin1 +WM-SETTEXT+ nil (string-pointer "OK!!!"))
    (set-window-color hwin1 (rgb-color 212 208 200))

    (set-focus hwin1 hwin2)
    (set-window-color hwin2 (rgb-color 212 208 200))

    (setq wcount 0)
    (loop                                 ;;------------- [0]  [1]  [2]   [3]
        (setf xmsg (get-window-message))  ;; return (list HWND MSG WPARAM LPARAM)

        (when (eql (nth 1 xmsg) +WM-COMMAND+)
            (when (eql (nth 3 xmsg) hbutt)
                (setq wcount (1+ wcount))
                (send-message hedit +WM-SETTEXT+ nil (string-pointer (princ-to-string wcount)))
                (princ wcount)
                (print " - press button hbutt-win2"))
            (when (eql (nth 3 xmsg) hbut1)
                (send-message hedi1 +WM-SETTEXT+ nil (string-pointer (string "ok-butt-win1")))))

        (when (eql (nth 1 xmsg) +WM-CLOSE+)
            (when (eql (nth 0 xmsg) hwin1)
                (send-message hwin2 +WM-CLOSE+)
                (print "close window1")
                (return))
            (when (eql (nth 0 xmsg) hwin2)
                (center-window hwin1)
                (print "close window2"))))

    (setf temp-str
        (make-string (1+ (send-message *XLISP-WINDOW* +WM-GETTEXTLENGTH+))
             :initial-element #\Space))

    (send-message *XLISP-WINDOW* +WM-GETTEXT+ (length temp-str)
        (string-pointer temp-str))

    (set-focus nil *XLISP-WINDOW*)
    (show-window *XLISP-WINDOW* +SW-RESTORE+)

    (string-right-trim "\000" temp-str))

